/* circulo.c --- 
*
* Copyright (C) 2009 Antonio-M. Corbi Bellot
*
* Author: Antonio-M. Corbi Bellot <antonio.corbi@ua.es>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2, or (at
* your option) any later version.

* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include "figura.h"
#include "circulo.h"

void Circulo__dibujar(struct Circulo *self)
{
    struct Circulo *cself = self;

    printf("Dibujamos un circulo en X:%d Y:%d y R:%d\n",
	   cself->cb.x, cself->cb.y, cself->r);
}

struct CirculoClass circulo_class = {
    "Circulo",
    Figura__seleccionar,
    Figura__esta_seleccionada,
    Circulo__dibujar
};

struct Circulo *crear_circulo(int x, int y, int r)
{
    struct Circulo *c;

    c = malloc(sizeof(struct Circulo));
    c->cb.dc = (figuraclass_ptr) &circulo_class;
    c->cb.x = x;
    c->cb.y = y;
    c->r = r;

    return c;
}
