
/* main.c --- 
*
* Copyright (C) 2009 Antonio-M. Corbi Bellot
*
* Author: Antonio-M. Corbi Bellot <antonio.corbi@ua.es>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2, or (at
* your option) any later version.

* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301, USA.
*/

#include <stdlib.h>
#include <stdio.h>

/*
 * Prueba de la jerarquia de clases.
 */
#include "figura.h"
#include "rectangulo.h"
#include "circulo.h"

int main()
{
    int            i;
    figura_ptr     f[2];
    rectangulo_ptr r = NULL;
    circulo_ptr    c = NULL;

    r = crear_rectangulo(10, 10, 30, 20);
    c = crear_circulo(50, 40, 25);

    /* enlace estatico */
    printf("Prueba de Enlace Estatico\n=========================\n");
    Circulo__dibujar(c);
    Rectangulo__dibujar(r);

    Figura__seleccionar((struct Figura *) c);

    /* enlace dinamico */
    printf("\n\nPrueba de Enlace Dinamico\n=========================\n");
    f[0] = (struct Figura *) c;
    f[1] = (struct Figura *) r;
    for (i = 0; i < 2; i++) {
      f[i]->dc->dibujar(f[i]);
      if (f[i]->dc->esta_seleccionada(f[i]))
	printf("SI esta seleccionado.\n\n");
      else
	printf("NO esta seleccionado.\n\n");
    }
}
