/* rectangulo.c --- 
*
* Copyright (C) 2009 Antonio-M. Corbi Bellot
*
* Author: Antonio-M. Corbi Bellot <antonio.corbi@ua.es>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License as
* published by the Free Software Foundation; either version 2, or (at
* your option) any later version.

* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.

* You should have received a copy of the GNU General Public License
* along with this program; see the file COPYING.  If not, write to
* the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include "figura.h"
#include "rectangulo.h"

void Rectangulo__dibujar(struct Rectangulo *self)
{
    struct Rectangulo *rself = self;

    printf("Dibujamos un rectangulo en X:%d Y:%d y W:%d H:%d\n",
	   rself->cb.x, rself->cb.y, rself->w, rself->h);
}

struct RectanguloClass rectangulo_class = {
    "Rectangulo",
    Figura__seleccionar,
    Figura__esta_seleccionada,
    Rectangulo__dibujar
};

struct Rectangulo *crear_rectangulo(int x, int y, int w, int h)
{
    struct Rectangulo *r;

    r = malloc(sizeof(struct Rectangulo));
    r->cb.dc = (figuraclass_ptr) &rectangulo_class;
    r->cb.x = x;
    r->cb.y = y;
    r->w = w;
    r->h = h;

    return r;
}
